class Fakul {
	/**
	 * Converts the input string into an int-Value.
	 *
	 * @throws BadFactorialArgException if the argument is missing, parsing fails
	 *         or the value is not in [0 ... 170].
	 */
	static int convertInput(String instr) {
		int arg;
		try {
			if (instr == null)
				throw new BadFactorialArgException("String-Parameter ist null.", "", 1, -1);
			arg = Integer.parseInt(instr);
			if (arg < 0  || arg > 170)
				throw new BadFactorialArgException(
					"Unzulässiger Wert (erlaubt: 0 bis 170)", instr, 3, arg);
			else
				return arg;
		} catch (NumberFormatException e) {
			throw new BadFactorialArgException("Fehler beim Konvertieren", instr, 2, -1);
		}
	}

	public static void main(String[] args) {
		int argument = -1;
		try {
			argument = convertInput(args[0]);
			double fakul = 1.0;
			for (int i = 1; i <= argument; i++)
				fakul = fakul * i;
			System.out.println("Fakultät: " + fakul);
		} catch(ArrayIndexOutOfBoundsException e) {
			System.out.println("Kein Argument angegeben");
		} catch (BadFactorialArgException e) {
			System.out.println("Fehlerhaftes Argument: " + e.getMessage());
			switch (e.getError()) {
				case 2 :	System.out.println("Zeichenfolge: \"" + e.getInstr() + "\"");
							break;
				case 3 :	System.out.println("Wert: " + e.getValue());
							break;
			}
		}
	}
}
