import java.io.*;

class TryWithResources9 {
    static void mean(String eingabe) throws FileNotFoundException {
        DataInputStream dis = new DataInputStream(new FileInputStream(eingabe));
        try (dis) {
            double sum = 0.0;
            int n = 0;
            while (dis.available() > 0) {
                n++;
                sum += dis.readDouble();
            }
            System.out.println("Mittelwert: " + sum/n);
        } catch (IOException ioe) {
            ioe.printStackTrace();
        }
    }

    static void createData(String eingabe) {
        try (DataOutputStream dos = new DataOutputStream(new FileOutputStream(eingabe))) {
            java.util.Random ran = new java.util.Random();
            for (int i = 1; i <= 100; i++)
                dos.writeDouble(ran.nextDouble());
        } catch (IOException ioe) {
            ioe.printStackTrace();
        }
    }

    public static void main(String args[]) throws FileNotFoundException {
        createData("eingabe.dat");
        mean("eingabe.dat");
    }
}