import java.util.*;
import java.util.concurrent.locks.ReentrantLock;

class FinallyDemo implements Runnable {
	int konto;
	ReentrantLock lock = new ReentrantLock();
	Random ran = new Random();
	
	public void run() {
		while (true) {
			lock.lock();
			konto += ran.nextInt(30);
			System.out.print("\nKontostand erhöht auf: "+konto);
			lock.unlock();
			try {
				Thread.sleep(1000);
			} catch (InterruptedException ignored) {
				// Die Ausnahme darf ignoriert werden, weil der Thread nicht abgebrochen wird.
			}
		}
	}

	void abheben() {
		Scanner input = new Scanner(System.in);
		int amount;
		while (true) {
			try {
				Thread.sleep(3000);
			} catch (InterruptedException ignored) {
				// Die Ausnahme darf ignoriert werden, weil der Thread nicht abgebrochen wird.
			}
			lock.lock();
			try {
				System.out.print("\n\nWelcher Betrag soll abgehoben werden (Beenden mit Betrag < 0): ");
				amount = Integer.parseInt(input.nextLine());
				if (amount < 0) {
					System.exit(0);
				}
				konto -= amount;
				System.out.println("Neuer Kontostand:  " + konto);
			} catch(NumberFormatException e) {
				System.out.println("Kein gültiger Betrag!");
			} finally {
				lock.unlock();
			}
		}
	}

	public static void main(String args[]) {
		FinallyDemo fd = new FinallyDemo();
		(new Thread(fd)).start();
		fd.abheben();
	}
}
