class SwitchJ17 {
    // traditionelle switch-Anweisung (keine Exhaustivität erforderlich)
    static void test(int i) {
        switch (i) {
            case 1: System.out.println(100);
            case 2: System.out.println(200);
        };
    }

    static int mapIntervals(Double dbl) {
            return switch (dbl) {
                case Double d && d <= 5.0                 -> 1;
                case Double d && d > 5.0 && d <= 10.0     -> 2;
                case Double d && d > 10.0 && d <= 100.0   -> 3;
                default                                   -> 4;
            };

//        if (dbl <= 5.0)
//            return 1;
//        else if (dbl <= 10.0)
//            return 2;
//        else if (dbl <= 100)
//            return 3;
//        else
//            return 4;
    }

    public static void main(String[] args) throws Exception {
        // switch-Ausdruck mit Mustervergleich
        Object s = "123";
        int resultEx = switch (s) {
            case String a && a.length() == 3     -> 1;
            case Integer i && i >= 5 && i <= 10  -> 2;
            default                              -> 3;
            case null                            -> -99;
        };
        System.out.println(resultEx);

        // switch-Anweisung mit Mustervergleich und Pfeil-Syntax (Exhaustivität erforderlich)
        int resSt = 0;
        switch (s) {
            case Integer i && i >= 5 && i <= 10 ->  resSt = i;
            case String a ->                        resSt = a.length();
            default ->                              resSt = -99;
        };

        // switch-Anweisung mit Mustervergleich und Doppelpunkt-Syntax (obligatorisches break)
        switch (s) {
            case Integer i && i >= 5 && i <= 10: resSt = i; break;
            case String a:                       resSt = a.length(); break;
            default:                             resSt = -99;
        };
        System.out.println(resSt);

        // Intervallbeurteilung durch Mustervergleiche
        System.out.println(mapIntervals(127.0));
    }
}
