import java.io.*;
import java.nio.file.*;

class DataOutputStreamDemo {
	public static void main(String[] args) throws IOException{
		Path file = Paths.get("demo.dat");

		// int, double und String schreiben
		try (DataOutputStream dos = new DataOutputStream(Files.newOutputStream(file))) {
			dos.writeInt(4711);
			dos.writeDouble(Math.PI);
			dos.writeUTF("DataOutputStream-Demo");
		}
		
		// int, double und String lesen
		try (DataInputStream dis = new DataInputStream(Files.newInputStream(file))) {
			System.out.println("readInt() - Ergebnis:    " + dis.readInt() +
							   "\nreadDouble() - Ergebnis: " + dis.readDouble() +
							   "\nreadUTF() - Ergebnis:    " + dis.readUTF());
		}
	}
}