import java.util.concurrent.CompletableFuture;

class TryGetCatch {
	public static void main(String[] args) throws InterruptedException {
		CompletableFuture<Integer> cf1 = CompletableFuture.supplyAsync(() -> {
			System.out.println("Starter:       " + Thread.currentThread().getName());
			if (true)
				throw new IllegalStateException("Starter failed");
			return 1;
		});

		CompletableFuture<Integer> cf2 = cf1.thenApplyAsync(i -> {
			System.out.println("Incrementer:   " + Thread.currentThread().getName());
			return ++i;
		});

		CompletableFuture<Void> result = cf2.thenAcceptAsync(i -> {
			System.out.println("Accepter:      " + Thread.currentThread().getName());
			System.out.println("Ergebnis = " + i);
		});

		// Die Verarbeitungskette erhält Zeit zum Terminieren.
		Thread.sleep(1000);
		System.out.println("\nVerarbeitung abgebrochen? " + result.isCompletedExceptionally());

		try {
			Void r = result.get();
			System.out.println("\nresult = " + r);
		} catch (Exception ex) {
			System.out.println("\n" + ex);
		}
		System.out.println("\nStarter:       " + cf1);
		System.out.println("Incrementer:   " + cf2);
		System.out.println("Result:        " + result);
	}
}
