import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.TimeUnit;

class UnbemerkteAusnahme {
	public static void main(String[] args) throws InterruptedException {
		CompletableFuture<Integer> cf1 = CompletableFuture.supplyAsync(() -> {
			System.out.println("Starter:       " + Thread.currentThread().getName());
			if (true)
				throw new IllegalStateException("Starter failed");
			return 1;
		});

		CompletableFuture<Integer> cf2 = cf1.thenApplyAsync(i -> {
			System.out.println("Incrementer:   " + Thread.currentThread().getName());
			return ++i;
		});

		CompletableFuture<Void> result = cf2.thenAcceptAsync(i -> {
			System.out.println("Accepter:      " + Thread.currentThread().getName());
			System.out.println("Ergebnis = " + i);
		});

		ForkJoinPool.commonPool().awaitQuiescence(3000, TimeUnit.MILLISECONDS);
	}
}
