import java.util.List;
import java.util.concurrent.*;

class AllOf {
	public static void main(String[] args)  throws InterruptedException {
		CompletableFuture<Integer> cf1 = CompletableFuture.supplyAsync(() -> {
			System.out.println("First:      " + Thread.currentThread().getName());
			try {Thread.sleep(1000);}
			catch (InterruptedException ix) {Thread.currentThread().interrupt();}
			return 1;
		});

		CompletableFuture<Integer> cf2 = CompletableFuture.supplyAsync(() -> {
			System.out.println("Second:     " + Thread.currentThread().getName());
			try {Thread.sleep(1000);}
			catch (InterruptedException ix) {Thread.currentThread().interrupt();}
			return 2;
		});

		CompletableFuture<Integer> cf3 = CompletableFuture.supplyAsync(() -> {
			System.out.println("Third:      " + Thread.currentThread().getName());
			try {Thread.sleep(1000);}
			catch (InterruptedException ix) {Thread.currentThread().interrupt();}
			if (true)
				throw new IllegalStateException("Third task failed");
			return 3;
		});

		CompletableFuture<Void> cfa = CompletableFuture.allOf(cf1, cf2, cf3);
		cfa.whenCompleteAsync((i, ex) -> {
			if (ex != null) {
				System.out.println("\nTask series failed with exception:");
				System.out.println("  Cause:   " + ex.getCause().getClass().getName());
				System.out.println("  Message: " + ex.getCause().getMessage());
			}
			for(var cf: List.of(cf1, cf2, cf3))
				System.out.println(cf.join());
		});

		ForkJoinPool.commonPool().awaitQuiescence(3000, TimeUnit.MILLISECONDS);
	}
}