import java.util.concurrent.CompletableFuture;

class AnyOf {
	public static void main(String[] args)  {
		CompletableFuture<Integer> cf1 = CompletableFuture.supplyAsync(() -> {
			try {Thread.sleep(200);} catch (InterruptedException ix) {Thread.currentThread().interrupt();}
			System.out.println("First:      " + Thread.currentThread().getName());
			return 1;
		});

		CompletableFuture<Integer> cf2 = CompletableFuture.supplyAsync(() -> {
			try {Thread.sleep(100);} catch (InterruptedException ix) {Thread.currentThread().interrupt();}
			System.out.println("Second:     " + Thread.currentThread().getName());
			return 2;
		});

		CompletableFuture<Integer> cf3 = CompletableFuture.supplyAsync(() -> {
			try {Thread.sleep(100);} catch (InterruptedException ix) {Thread.currentThread().interrupt();}
			System.out.println("Third:      " + Thread.currentThread().getName());
			if (true)
				throw new IllegalStateException("Third task failed");
			return 3;
		});

		CompletableFuture<Object> cfa = CompletableFuture.anyOf(cf1, cf2, cf3);
		try {
			System.out.println(cfa.join());
		} catch (Exception ex) {
			System.out.println("Exception\n Class:     " + ex.getClass().getName());
			System.out.println(" Cause:     " + ex.getCause().getClass().getName());
			System.out.println(" Message:   " + ex.getCause().getMessage());
		} finally {
			System.out.println("Task:       " + cfa);
		}
	}
}