import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.TimeUnit;

class Handle {
	public static void main(String[] args)  {
		CompletableFuture<Integer> cf1 = CompletableFuture.supplyAsync(() -> {
			System.out.println("Starter:       " + Thread.currentThread().getName());
			try {Thread.sleep(100);} catch (InterruptedException ix) {Thread.currentThread().interrupt();}
			if (true)
				throw new IllegalStateException("Starter failed");
			return 1;
		});

		CompletableFuture<Integer> cf2 = cf1.handleAsync((i, ex) -> {
			if (ex != null)  {
				System.out.println("\nAusnahme:      " + ex);
				System.out.println("Reset to 0:    " + Thread.currentThread().getName() + "\n");
				try {Thread.sleep(100);} catch (InterruptedException ix) {Thread.currentThread().interrupt();}
				i = 0;
			}
			System.out.println("Incrementer:   " + Thread.currentThread().getName());
			try {Thread.sleep(100);} catch (InterruptedException ix) {Thread.currentThread().interrupt();}
			return ++i;
		});

		CompletableFuture<Void> result = cf2.thenAcceptAsync(i -> {
			System.out.println("Accepter:      " + Thread.currentThread().getName());
			try {Thread.sleep(100);} catch (InterruptedException ix) {Thread.currentThread().interrupt();}
			System.out.println("\nResult = " + i);
		});

		result.join();
	}
}

