import java.util.concurrent.*;

class ThenApplyAsync {
	public static void main(String[] args)  throws InterruptedException {
		CompletableFuture<Integer> cf1 = CompletableFuture.supplyAsync(() -> {
			System.out.println("First:       " + Thread.currentThread().getName());
			try {Thread.sleep(1000);} catch (InterruptedException ix) {Thread.currentThread().interrupt();}
			return 1;
		});
		try {Thread.sleep(3000);} catch (InterruptedException ix) {Thread.currentThread().interrupt();}

		CompletableFuture<Void> cfv = CompletableFuture.runAsync(() -> {
			try {Thread.sleep(3000);} catch (InterruptedException ix) {Thread.currentThread().interrupt();}
			System.out.println("Sleeper:     " + Thread.currentThread().getName());
		});

		CompletableFuture<Integer> cf2 = cf1.thenApplyAsync(i -> {
			System.out.println("Incrementer: " + Thread.currentThread().getName());
			try {Thread.sleep(1000);} catch (InterruptedException ix) {Thread.currentThread().interrupt();}
			return ++i;
		});

//		ExecutorService es = Executors.newCachedThreadPool();
//		CompletableFuture<Integer> cf2 = cf1.thenApplyAsync(i -> {
//			System.out.println("Incrementer: " + Thread.currentThread().getName());
//			try {Thread.sleep(1000);} catch (InterruptedException ix) {Thread.currentThread().interrupt();}
//			return ++i;
//		}, es);
//		es.shutdown();

		System.out.println(cf2.join());
		ForkJoinPool.commonPool().awaitQuiescence(3000, TimeUnit.MILLISECONDS);
	}
}

