import java.util.concurrent.CompletableFuture;

class WhenCompleteAsync {
	public static void main(String[] args)  throws Exception {
		CompletableFuture<Integer> cf1 = CompletableFuture.supplyAsync(() -> {
			System.out.println("Starter:       " + Thread.currentThread().getName());
			if (true)
				throw new IllegalStateException("Starter failed");
			return 1;
		});

		CompletableFuture<Integer> cf2 = cf1.thenApplyAsync(i -> {
			System.out.println("Incrementer:   " + Thread.currentThread().getName());
			return ++i;
		});

//		CompletableFuture<Void> ac = cf1.thenAcceptAsync(i -> {
//			System.out.println("Accepter:   " + Thread.currentThread().getName());
//		});

//		ac.whenCompleteAsync((i, ex) -> {
//			if (i == null) {
//				System.out.println("i ist null");
//			}
//			if (ex == null) {
//				System.out.println("ex ist null");
//			}
//		});

		CompletableFuture<Integer> result = cf2.whenCompleteAsync((i, ex) -> {
			if (ex != null) {
				System.out.println(ex.getClass());
				System.out.println("  Cause:   " + ex.getCause().getClass().getName());
				System.out.println("  Message: " + ex.getCause().getMessage());
			}
			System.out.println("Accepter:      " + Thread.currentThread().getName());
			System.out.println("Ergebnis = " + i);
		});

		try {
			System.out.println(result.get());
		} catch (Exception ex) {
			System.out.println(ex.getMessage());
		}
	}
}

