import java.util.concurrent.*;

class PublisherDemo {
	public static void main(String[] args) throws InterruptedException {

		ExecutorService es = Executors.newCachedThreadPool();
		SubmissionPublisher<Integer> publisher = new SubmissionPublisher<>(es, 2);

		publisher.subscribe(new DemoSubscriber());
		publisher.subscribe(new DemoSubscriber());

		System.out.println("Die Auslieferung beginnt.");
		for (int i = 1; i <= 5; i++)
			publisher.submit(i);

		publisher.close();
		System.out.println("Der Publisher ist geschlossen");

		es.shutdown();
	}
}