import java.util.concurrent.*;

class PublisherDemo {
	public static void main(String[] args) throws InterruptedException {
		SubmissionPublisher<Integer> publisher = new SubmissionPublisher<>();

		publisher.subscribe(new DemoSubscriber());

		System.out.println("Die Auslieferung beginnt.");
		for (int i = 1; i <= 5; i++)
			publisher.submit(i);

		publisher.close();
		System.out.println("Der Publisher ist geschlossen");

		// Verhindert, dass sich der main-Thread an den Restarbeiten beteiligt:
		Thread.sleep(100);
		// Der Common-Threadpool erhält Zeit, um die Restarbeiten:
		ForkJoinPool.commonPool().awaitQuiescence(10, TimeUnit.SECONDS);
	}
}