import java.net.URI;
import java.net.http.*;
import java.nio.file.*;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.concurrent.CompletableFuture;

class HttpClientAsyncGetFile {
	public static void main(String[] args) {
		String uri = "https://www.uni-trier.de/";
		try {
			HttpClient client = HttpClient.newHttpClient();
			HttpRequest request = HttpRequest.newBuilder()
											 .uri(URI.create(uri))
											 .build();
			SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
			String date = simpleDateFormat.format(new Date());
			Path file = Paths.get(request.uri().getHost() + "." + date + ".html");
			CompletableFuture<HttpResponse<Path>> cfHRS = client.sendAsync(request, HttpResponse.BodyHandlers.ofFile(file));
			for (int i = 0; !cfHRS.isDone(); i++) {
				System.out.println("i = " + i);
				Thread.sleep(100);
			}
			Path p = cfHRS.join().body();
			System.out.println("Ausgabe in die Datei " + p + ", Größe: " + Files.size(p));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
