import java.net.URI;
import java.net.http.*;
import java.util.concurrent.CompletableFuture;

class HttpClientAsyncGetString {
	public static void main(String[] args) {
		String uri = "https://www.uni-trier.de/";
		try {
			HttpClient client = HttpClient.newHttpClient();
			HttpRequest request = HttpRequest.newBuilder()
											 .uri(URI.create(uri))
											 .build();
			CompletableFuture<HttpResponse<String>> cfHRS = client.sendAsync(request, HttpResponse.BodyHandlers.ofString());
			for (int i = 0; !cfHRS.isDone(); i++) {
				System.out.println("i = " + i);
				Thread.sleep(100);
			}
			String s = cfHRS.join().body();
			System.out.printf("HTML-Code mit %d Zeichen erhalten.", s.length());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
