import java.io.*;
import java.net.URI;
import java.net.URLEncoder;
import java.net.http.*;

class HttpClientSyncPostString {
	public static void main(String[] args) {
		try (BufferedReader in = new BufferedReader(new InputStreamReader(System.in))) {
			System.out.print("Vorname:  ");
			String vorname = in.readLine();
			System.out.print("Nachname: ");
			String nachname = in.readLine();
			System.out.println();

			String uri = "https://urtkurs.uni-trier.de/prokur/netz/cgip.php";
			String name = "vorname=" + URLEncoder.encode(vorname, "UTF-8") + "&nachname=" + URLEncoder.encode(nachname, "UTF-8");
			HttpRequest request = HttpRequest.newBuilder()
					.uri(URI.create(uri))
					.header("Content-Type", "application/x-www-form-urlencoded")
					.POST(HttpRequest.BodyPublishers.ofString(name))
					.build();

			HttpClient client = HttpClient.newHttpClient();
			HttpResponse<String> response = client.send(request, HttpResponse.BodyHandlers.ofString());
			System.out.printf("Statuscode: %d\n\n", response.statusCode());
			java.util.StringTokenizer stok = new java.util.StringTokenizer(response.body(), "\n", false);
			while (stok.hasMoreTokens()) {
				System.out.println(stok.nextToken());
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
