import java.io.*;
import java.net.*;
import java.util.*;
import java.text.*;

class DaytimeServer {
	public static void main(String[] args) {
		DateFormat df = DateFormat.getDateTimeInstance();
		String zeit;

		try (ServerSocket timeServer = new ServerSocket(13);) {
			System.out.println("Zeitserver gestartet (" + df.format(new Date()) + ")");
			while(true)
				try (Socket client = timeServer.accept()) {
					PrintWriter pw = new PrintWriter(client.getOutputStream(), true);
					zeit = df.format(new Date());
					System.out.println("\n" + zeit + " Anfrage von\n  IP-Nummer: " +
							client.getInetAddress().getHostAddress() +
							" (Port: " + client.getPort() + ")");
					pw.println(zeit);
				}
		} catch (Exception e) {
			System.err.println(e);
		}
	}
}