import java.net.*;
import java.util.*;
import java.util.concurrent.*;
import java.text.*;

class EchoServer {
	private static int nconn, nummer;
	private static DateFormat df = DateFormat.getDateTimeInstance();

	public static void main(String[] args) {
		ExecutorService es = Executors.newCachedThreadPool();
		try (ServerSocket echoServer = new ServerSocket(7)) {
			System.out.println("Echoserver gestartet (" + df.format(new Date()) + ")");
			while(true) {
				try {
					Socket client = echoServer.accept();
					nconn++;
					nummer++;
					prot("Verbindung Nummer " + nummer + ":\n  IP-Nummer: "
							+ client.getInetAddress().getHostAddress()
							+ " (Port: " + client.getPort() + ")");
					es.execute(new EchoTask(client, nummer));
				} catch (Exception e) {
					prot("Fehler bei der Klientenbedienung: \n  " + e);
				}
			}
		} catch (Exception e) {
			prot("Server konnte nicht gestartet werden: \n  " + e);
		}
	}

	static synchronized void decr(int nummer) {
		nconn--;
		System.out.println("\n" + df.format(new Date()) + " Verbindung Nummer " + nummer + " beendet");
	}

	static synchronized int getNConnects() {return nconn;}
	
	static void prot(String s) {
		System.err.println("\n" + df.format(new Date()) + " "+s);
	}
}