import de.uni_trier.zimk.figuren.*;
class FigurenDemo {
	public static void main(String[] ars) {
		// Bei den in Java 17 für switch-Anweisungen und switch-Ausdrücke eingeführten Mustervergleichen
		// berücksichtigt der Compiler versiegelte Klassen, sodass ggf. kein default-Fall erforderlich ist,
		// um die Exhaustivität herzustellen.
		Figur[] fa = new Figur[3];
		fa[0] = new Kreis(50.0, 50.0, 50.0);
		fa[1] = new Rechteck(50.0, 10.0, 100.0, 100.0);
		fa[2] = new Quadrat(150.0, 110.0, 30.0);
		double x  = 100.0, y = 100.0;
		for (var f : fa)
			switch (f) {
				case Kreis fig -> System.out.println("Radius: " + fig.meldeRadius());
				case Rechteck fig -> System.out.println("Breite: " + fig.meldeBreite());
				case Quadrat fig -> System.out.println("Seitenlänge: " + fig.meldeSeite());
			}

		// Verbesserte Fehlererkennung durch den Compiler aufgrund der Versiegelung
		Quadrat q = new Quadrat(150.0, 110.0, 30.0);
//		Comparable cq = (Comparable) q; // Laufzeitfehler
		Rechteck r = new Rechteck(50.0, 10.0, 100.0, 100.0);
//		Comparable cr = (Comparable) r; // Compiler entdeckt den Fehler









	}
}