package de.uni_trier.zimk.figuren;

public non-sealed class Quadrat extends Figur {
	protected double seite = 50.0;
	
	public Quadrat(double x, double y, double s) {
		super(x, y);
		if (s >= 0) {
			seite = s;
		}
	}
	
	public Quadrat() {}
	
	@Override
	public double abstand(double x, double y) {
		return Math.sqrt(Math.pow(xpos+seite/2-x,2) + Math.pow(ypos+seite/2-y,2));
	}

	@Override
	public void wo() {
		super.wo();
		System.out.println("Unten rechts: (" + (xpos+seite) + ", " + (ypos+seite) + ")");
	}

	@Override
	public double meldeInhalt() {
		return seite * seite;
	}

	public double meldeSeite() {
		return seite;
	}
}


