package de.uni_trier.zimk.figuren;

public sealed class Rechteck extends Figur permits RechteckZ {
	protected double breite = 50.0, hoehe = 50.0;
	
	public Rechteck(double x, double y, double b, double h) {
		super(x, y);
		if (b >= 0 && h >= 0) {
			breite = b;
			hoehe = h;
		}
	}
	
	public Rechteck() {}
	
	@Override
	public double abstand(double x, double y) {
		return Math.sqrt(Math.pow(xpos+breite/2-x,2) + Math.pow(ypos+hoehe/2-y,2));
	}

	@Override
	public void wo() {
		super.wo();
		System.out.println("Unten rechts: (" + (xpos+breite) + ", " + (ypos+hoehe) + ")");
	}

	@Override
	public double meldeInhalt() {
		return breite * hoehe;
	}

	public double meldeBreite() {
		return breite;
	}
}


