class SBBBench {
    final static int DRL = 100_000;
    static long vorher, diff;

    public static void main(String[] args) throws Exception {
        String s = "*";
        vorher = System.currentTimeMillis();
        for (int i = 0; i < DRL; i++)
            s = s + "*";
        diff = System.currentTimeMillis() - vorher;
        System.out.println("Zeit in Millisekunden für die ...");
        System.out.printf("  %-30s %7d\n", "String-\"Verlängerung\":", diff);

        StringBuilder sbuild = new StringBuilder("*");
        runAppend(sbuild);

        StringBuffer sbuff = new StringBuffer("*");
        runAppend(sbuff);
    }

    static void runAppend (Appendable cs) throws Exception {
        vorher = System.currentTimeMillis();
        for (int i = 0; i < DRL; i++)
            cs.append("*");
        String s = cs.toString();
        diff = System.currentTimeMillis() - vorher;
        System.out.printf("  %-30s %7d\n", cs.getClass().getSimpleName() + " - Verlängerung: ", diff);
    }
}
