class StringIntern {
	public static void main(String[] args) {
		final int anz = 50_000, len = 20, wdh = 50;
		StringBuffer sb = new StringBuffer();
		java.util.Random ran = new java.util.Random();
		String[] sar = new String[anz];
		
		// Zufallszeichenfolgen mit Hilfe eines StringBuiler-Objekts erzeugen
		for (int i = 0; i < anz; i++) {
			for (int j = 0; j < len; j++)
				sb.append((char) (65 + ran.nextInt(26)));
			sar[i] = sb.toString();
			sb.delete(0, len);
		}
		
		long start = System.currentTimeMillis();
		int hits = 0;
		// Inhaltsvergleiche
		for (int n = 1; n <= wdh; n++)
			for (int i = 0; i < anz; i++)
				if (sar[i].equals(sar[ran.nextInt(anz)]))
					hits++;
		System.out.println((wdh * anz) + " Inhaltsvergleiche (" + hits +
				" hits) benötigen "+(System.currentTimeMillis()-start) + " Millisekunden");
		
		start = System.currentTimeMillis();
		hits = 0;

		// Internieren
		for (int j = 1; j < anz; j++)
			sar[j] = sar[j].intern();
		System.out.println("\nZeit für das Internieren: " +
				(System.currentTimeMillis()-start) + " Millisekunden");
		
		// Adressvergleiche
		for (int n = 1; n <= wdh; n++)
			for (int i = 0; i < anz; i++)
				if (sar[i] == sar[ran.nextInt(anz)])
					hits++;
		System.out.println((wdh * anz) + " Adressvergleiche (" + hits +
				" hits) benötigen (inkl. Internieren) " + (System.currentTimeMillis()-start) + " Millisekunden");
	}
}
