public class StringUtil {
	final static int NCOL_DEF = 72;
	final static String DELIM_DEF = " \t\n\r\f-";

	public static void wrapln(String text, String delim, int ncol) {
		StringBuffer token = new StringBuffer();
		StringBuffer zeile = new StringBuffer();
		java.util.StringTokenizer stok = new java.util.StringTokenizer(text, delim, true);

		while (stok.hasMoreTokens()) {
			token.replace(0, token.length(), stok.nextToken());
			
			// Nach einem Zeilentrennzeichen wird der aktuelle Text ausgegeben und eine neue Zeile begonnen.
			if (isLineSep(token.charAt(0))) {
				write(zeile);
				zeile.delete(0, zeile.length());
				continue;
			}
			
			if (zeile.length() + token.length() <= ncol) {
				zeile.append(token);
			} else {
				write(zeile);
				while (token.length() > ncol) {
					zeile.replace(0, zeile.length(), token.substring(0, ncol));
					write(zeile);
					token.delete(0, ncol);
				}
				zeile.replace(0, zeile.length(), token.toString());
			}
		}
		write(zeile);
	}

	private static boolean isLineSep(char c) {
		if (c == '\n' || c == '\r' || c == '\f')
			return true;
		else
			return false;
	}
	
	private static void write(StringBuffer zeile) {
		while (zeile.length() > 0 && zeile.charAt(0) == ' ')
			zeile.deleteCharAt(0);
		if (zeile.length() > 0)
			System.out.println(zeile);
	}

	public static void wrapln(String text, int ncol) {
		wrapln(text, DELIM_DEF, ncol);
	}

	public static void wrapln(String text) {
		wrapln(text, DELIM_DEF, NCOL_DEF);
	}	
}
